/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "jabber.h"

#ifndef __JABPRIVATE_H
#define __JABPRIVATE_H

/* Callbacks */

typedef void (*_jabcbe_on)(jabc j);
typedef void (*_jabcbe_off)(jabc j, int err);
typedef void (*_jabcbe_msg)(jabc j, jabm msg);
typedef void (*_jabcbe_prs)(jabc j, jabp prs);
typedef void (*_jabcbe_iq)(jabc j, jabq iq);
typedef void (*_jabcbe_auth)(jabc j, int type);
typedef void (*_jabcbe_roster)(jabc j, jabr r, int type);
typedef void (*_jabcbe_profile)(jabc j, jabpf pf);

extern _jabcbe_on _jabcb_on;
extern _jabcbe_off _jabcb_off;
extern _jabcbe_msg _jabcb_msg;
extern _jabcbe_prs _jabcb_prs;
extern _jabcbe_iq _jabcb_iq;
extern _jabcbe_auth _jabcb_auth;
extern _jabcbe_roster _jabcb_roster;
extern _jabcbe_profile _jabcb_profile;


/* Defines */

#define JAB_S_OFF 0
#define JAB_S_CONN 1
#define JAB_S_STREAM 2
#define JAB_S_ON 3


/* Prototypes */

void _jab_parsenode(jabc j, xmlnode x, int type);

void _jab_auth(jabc j);
void _jab_reg(jabc j);
void _jab_parseauth(jabc j, jabq iq, int type);

void _jabr_parse(jabc j, jabq iq);

void _jabpf_parse(jabc j, jabq iq);




#endif  /* __JABPRIVATE_H */
