/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "jabber.h"
#include "jabprivate.h"

void _jab_auth(jabc j)
{
    jabn node;
    xmlnode x,tmp;

    if (JAB_S_ON != j->state) return;

    x = xmlnode_new_tag("query");
    xmlnode_put_attrib(x,"xmlns","jabber:iq:auth");
    tmp = xmlnode_insert_tag(x,"username");
    xmlnode_insert_cdata(tmp,j->user->user,-1);
    tmp = xmlnode_insert_tag(x,"resource");
    xmlnode_insert_cdata(tmp,j->user->resource,-1);
    tmp = xmlnode_insert_tag(x,"password");
    xmlnode_insert_cdata(tmp,j->pass,-1);
    node = jab_newnode(JABN_IQ,
            JABQ_TYPE, JABQ_TYPE_SET,
            JABQ_QUERY, x,
            JABQ_DONE);
    jab_sendnode(j,node);
    xmlnode_free(x);
}


void _jab_reg(jabc j)
{
    jabn node;
    xmlnode x,tmp;

    if (JAB_S_ON != j->state) return;

    x = xmlnode_new_tag("query");
    xmlnode_put_attrib(x,"xmlns","jabber:iq:register");
    tmp = xmlnode_insert_tag(x,"username");
    xmlnode_insert_cdata(tmp,j->user->user,-1);
    tmp = xmlnode_insert_tag(x,"password");
    xmlnode_insert_cdata(tmp,j->pass,-1);
    node = jab_newnode(JABN_IQ,
            JABQ_TYPE, JABQ_TYPE_SET,
            JABQ_QUERY, x,
            JABQ_DONE);
    jab_sendnode(j,node);
    xmlnode_free(x);
}


void _jab_parseauth(jabc j, jabq iq, int type)
{
    xmlnode tmp;

    if(type==0) {
    if(iq->type == JABQ_TYPE_ERROR)
        (_jabcb_auth)(j,JAB_AUTH_FAIL);
    else if(iq->type == JABQ_TYPE_RESULT) {
        (_jabcb_auth)(j,JAB_AUTH_OK);
        if(j->flags&JABC_ROSTER) jabr_request(j);
        if(j->flags&JABC_PROFILE) jabpf_ask(j,NULL);
    }
    } else {
    if(iq->type == JABQ_TYPE_ERROR)
        (_jabcb_auth)(j,JAB_REG_FAIL);
    else if(iq->type == JABQ_TYPE_RESULT) {
        (_jabcb_auth)(j,JAB_REG_OK);
        _jab_auth(j);
    }
    }
}
